/**
 * Program: UDPanel.java
 * Comments: Controls the display of directories.
 * PrivilegeManager and Principal are part of the Netscape security 
 * package and are needed to escape the sandbox.
 * 
 * The string transferStatus is null, upload, or download.
 */

import WebFlow.*;
import WebFlow.RemoteFile.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.net.*;
import netscape.security.*;

public class UDPanel extends JPanel 
    implements ActionListener, MouseListener, TreeExpansionListener{

    PrivilegeManager privMan;
    netscape.security.Principal myPrincipal;

    String remoteDir="/tmp/";
    String localDir="C:\\";
    String osName;
    UDapplet applet;
    String transferState=null;
    FileTransferBean ftb;
    RemoteFile rf;
    TreePath tpRem,tpLoc;

    JTextField srcText,dstText,statusText;
    String srcTextVal="",dstTextVal="",statusTextVal="";
    JButton upload,download,transfer;
    JTextField remoteText, localText;
    JTextArea temp1,temp2;
    JPanel buttonPanel1,buttonPanel2,remotePanel,localPanel;
    JPanel basePanel1,basePanel2,directionPanel,commandPanel;
    JScrollPane JSPRemote,JSPLocal;
    JTree localTree,remoteTree;
    Box bigBox,biggerBox,commandBox;    
    URL leftImagePath,rightImagePath;
    String URLhost="",localPath="",remotePath="",localFile,remoteFile;

    public UDPanel(UDapplet applet) {
	this.applet=applet;
	ftb=applet.getFileTransferBean();
	rf=applet.getRemoteFileObj();
	rf.test();
	privMan=applet.getPrivMan();
	myPrincipal=applet.getMyPrincipal();
	URLhost=applet.getDocumentBase().getHost();

	//We need to remove these hard-coded paths eventually.
	try {
	    leftImagePath=
		new URL("http://birch.csit.fsu.edu:8001/GOW/applets/left.gif");
	    rightImagePath=
		new URL("http://birch.csit.fsu.edu:8001/GOW/applets/right.gif");
	}
	catch(Exception ex) {
	    ex.printStackTrace();
	}

	//Set the privileges for reading and writing files.
	privMan.enablePrivilege("UniversalFileRead");
	privMan.enablePrivilege("UniversalFileWrite");

	System.out.println("OS name: "+System.getProperty("os.name"));
	System.out.println("OS arch: "+System.getProperty("os.arch"));
	System.out.println("OS version: "+System.getProperty("os.version"));
	osName = System.getProperty("os.name");
	if(!osName.startsWith("Window")) localDir = "/tmp/";


        localTree=(applet.getLocalTree()).createTree(localDir);
	localTree.addMouseListener(this);
	localTree.addTreeExpansionListener(this);

        remoteTree=(applet.getRemoteTree()).createTree(remoteDir);
	remoteTree.addMouseListener(this);
	remoteTree.addTreeExpansionListener(this);
	initGui();
    }
    

    //This is a big ugly method that collects all the GUI stuff.
    private void initGui(){
	commandBox=Box.createVerticalBox();
	bigBox=Box.createHorizontalBox();
	biggerBox=Box.createVerticalBox();

	basePanel1=new JPanel();
	basePanel1.setLayout(new BorderLayout());
	basePanel2=new JPanel();
	basePanel2.setLayout(new BorderLayout());
	
	directionPanel=new JPanel();
	upload=new JButton("Uload",new ImageIcon(leftImagePath));
	upload.addActionListener(this);
	download=new JButton("Dload",new ImageIcon(rightImagePath));
	download.addActionListener(this);
	directionPanel.add(upload);
	directionPanel.add(download);
	
	commandPanel=new JPanel();
	commandPanel.setLayout(new GridLayout(4,1));
	JPanel srcPanel=new JPanel();
	JPanel dstPanel=new JPanel();
	JPanel statusPanel=new JPanel();
	JPanel transPanel=new JPanel();

	//cyoun change from 20 to 10
	srcText=new JTextField(10);
	srcText.setEditable(false);

	//cyoun change from 20 to 10
	dstText=new JTextField(10);
	dstText.setEditable(false);

	//cyoun change from 20 to 10
	statusText=new JTextField(10);

	statusText.setEditable(false);
	transfer=new JButton("Transfer Files!");
	transfer.addActionListener(this);
	transfer.setEnabled(false);
	srcPanel.setLayout(new BorderLayout());
	dstPanel.setLayout(new BorderLayout());
	srcPanel.add(new JLabel("Source:"),"West");
	srcPanel.add(srcText,"Center");
	dstPanel.add(new JLabel("Dest:"),"West");
	dstPanel.add(dstText,"Center");
	statusPanel.setLayout(new BorderLayout());
	statusPanel.add(new JLabel("Status:"),"West");
	statusPanel.add(statusText,"Center");
	transPanel.add(transfer);
	commandBox.add(srcPanel);
	commandBox.add(dstPanel);
	commandBox.add(statusPanel);
	commandBox.add(transPanel);
	JPanel commandPanel1=new JPanel();
	commandPanel1.setLayout(new BorderLayout());
	commandPanel1.add(commandBox,"South");

	//cyoun change from 30 to 20
	remoteText=new JTextField(20);
	localText=new JTextField(20);

	buttonPanel1=new JPanel();
	buttonPanel1.setLayout(new BorderLayout());
	buttonPanel2=new JPanel();
	buttonPanel2.setLayout(new BorderLayout());
	
	buttonPanel1.add(new JLabel("Remote File:"),"West");
	buttonPanel1.add(remoteText,"Center");
	buttonPanel2.add(new JLabel("Local File:"),"West");
	buttonPanel2.add(localText,"Center");
			 
	JSPRemote=new JScrollPane(remoteTree,ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
	JSPRemote.setPreferredSize(new Dimension(100,150));

	JSPLocal=new JScrollPane(localTree,ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
	JSPLocal.setPreferredSize(new Dimension(100,150));
	
	
	basePanel1.add(JSPRemote,"Center");
	basePanel1.add(buttonPanel1,"South");
	basePanel2.add(JSPLocal,"Center");
	basePanel2.add(buttonPanel2,"South");
	bigBox.add(basePanel1);
	bigBox.add(Box.createHorizontalStrut(50));
	bigBox.add(basePanel2);	

	biggerBox.add(directionPanel);
	biggerBox.add(bigBox);
	biggerBox.add(Box.createVerticalStrut(15));
	biggerBox.add(commandPanel1);
	add(biggerBox);
    }

    /**
     * Define the actions for the various buttons. Note the boolean 
     * uploadTest tells the target button if a file should be uploaded
     * (true) or downloaded (false).
     */
    public void actionPerformed(ActionEvent ev) {
	Object source=ev.getSource();
	if(source==upload) {
	    transferState="upload";
	    transfer.setEnabled(true);

  	    statusTextVal="Upload files to remote host.";
	    updateText(statusText,statusTextVal);

	    //cyoun added
	    localPath = localText.getText();

  	    srcTextVal="localhost:"+localPath;
	    updateText(srcText,srcTextVal);

	    //cyoun added
	    remotePath = remoteText.getText();

  	    dstTextVal=URLhost+":"+remotePath;
	    updateText(dstText,dstTextVal);
	}
	else if(source==download){
	    transferState="download";
	    transfer.setEnabled(true);

	    statusTextVal="Download files from remote host.";
	    updateText(statusText,statusTextVal);	    

	    //cyoun added
	    remotePath = remoteText.getText();

	    srcTextVal=URLhost+":"+remotePath;
	    updateText(srcText,srcTextVal);

	    //cyoun added
	    localPath = localText.getText();

	    dstTextVal="localhost:"+localPath;
	    updateText(dstText,dstTextVal);	    
	}

	
	//Transfer the files.  Must check if localPath and remotePath
	//are files or directories
	else if(source==transfer) {
	    //User has not selected an option.
	    if(transferState==null) {
		updateText(statusText,"Please select Uload or Dload");
	    }
	    //User wants to upload file/directory to remote host
	    else if(transferState.equals("upload")) {

		updateText(statusText,"Uploading file(s)");
		privMan.enablePrivilege("UniversalFileRead");
		privMan.enablePrivilege("UniversalFileWrite");

		try {
		    //cyoun added for debugging
		    System.out.println("localPATH(upload): "+localPath);
		    System.out.println("remotePATH(upload): "+remotePath);

                    if((new File(localPath)).isFile()) System.out.println("local Path is a file");
                    else System.out.println("local Path is not a file");
                    if((new File(localPath)).isDirectory()) System.out.println("local Path is a directory");
                    else System.out.println("local Path is not a directory");

                    if(rf.isFile(remotePath)) System.out.println("remote Path is a file");
                    else System.out.println("remote Path is not a file");

                    if(rf.isDirectory(remotePath)) System.out.println("remote Path is a directory");
                    else System.out.println("remote Path is not a directory");


		    if((new File(localPath)).isFile() && 
		       (rf.isFile(remotePath))) {

			System.out.println("local File-- remote File");
			ftb.FileSend(localPath,remotePath);
			updateText(statusText,"Files uploaded");
		    }
		    else if((new File(localPath)).isFile() &&
			    (rf.isDirectory(remotePath))){

			System.out.println("local File--remote Directory");

			localFile=(applet.getLocalTree()).getFileName(tpLoc);
			remotePath+=localFile;

			System.out.println("localFile(upload): "+localFile);
			System.out.println("remoteFile(upload): "+remotePath);

			boolean test=rf.createNewFile(remotePath);
			
			//cyoun added for debugging
			if(test) System.out.println("create new file is OK");
			else System.out.println("create new file is NOT OK");

			ftb.FileSend(localPath,remotePath);
			
			//cyoun added
			updateText(statusText,"Files uploaded");

		    }
		    else if((new File(localPath)).isDirectory() &&
			    (rf.isDirectory(remotePath))){
			ftb.DirectorySend(localPath,remotePath);
			updateText(statusText,"Directory uploaded");
		    }
		    else if((new File(localPath)).isDirectory() &&
			    (rf.isFile(remotePath))){
			updateText(statusText,"Error: cannot upload directory to a file");
		    }
		    else System.out.println("There is NO other cases above!!!!");
		}
		catch(Exception ex) {
		    updateText(statusText,"Error: could not upload");
		    System.out.println("Error in FileSend");
		    ex.printStackTrace();
		}
	    }
	    //User wants to download file/directory to local host.
	    else if(transferState.equals("download")){
		updateText(statusText,"Downloading file(s)");

		privMan.enablePrivilege("UniversalFileRead");
		privMan.enablePrivilege("UniversalFileWrite");
		try {
		    //cyoun added
		    System.out.println("localPATH(download): "+localPath);
		    System.out.println("remotePATH(download): "+remotePath);

		    if((new File(localPath)).isFile()) System.out.println("localPAth is a File");
		    else  System.out.println("localPAth is NOT a File");

		    if((new File(localPath)).isDirectory()) System.out.println("localPAth is a directory");
		    else  System.out.println("localPAth is NOT a directory");

		    if(rf.isFile(remotePath)) System.out.println("remotePAth is a File");
		    else  System.out.println("remotePAth is NOT a File");

		    if(rf.isDirectory(remotePath)) System.out.println("remotePAth is a Directory");
		    else  System.out.println("remotePAth is NOT a Directory");


		    if((new File(localPath)).isFile() && 
		       (rf.isFile(remotePath))) {
			ftb.FileReceive(localPath,remotePath);
			updateText(statusText,"File downloaded");
		    }
		    else if((new File(localPath)).isFile() &&
			    (rf.isDirectory(remotePath))){
			updateText(statusText,"Error: cannot download directory to a file");
			//cyoun added
			updateText(statusText,"File downloaded");
		    }
		    else if((new File(localPath)).isDirectory() &&
			    (rf.isDirectory(remotePath))){
			ftb.DirectoryReceive(localPath,remotePath);
			updateText(statusText,"Directory downloaded");
		    }
		    else if((new File(localPath)).isDirectory() &&
			    (rf.isFile(remotePath))){

			remoteFile=(applet.getRemoteTree()).getFileName(tpRem);
			//cyoun added
			if(osName.startsWith("Window")) remoteFile = "\\"+remoteFile;
			localPath+=remoteFile;
			System.out.println("localFile(download): "+localPath);
			System.out.println("remoteFile(download): "+remoteFile);

			//This is a workaround to create the file
			FileOutputStream tmp=new FileOutputStream(localPath);
			tmp.close();
			ftb.FileReceive(localPath,remotePath);
			updateText(statusText,"File downloaded");
		    }
		    else System.out.println("There is NO other cases above!!!!");
		}
		catch(Exception ex) {
		    updateText(statusText,"Error: could not upload");
		    System.out.println("Error in FileSend");
		    ex.printStackTrace();
		}
	    }
	    else { }
	    //transfer state not found.
	    transfer.setEnabled(false);
	}
	else {
	    System.err.println("Event not found");
	}
    }
    
    public void mouseClicked(MouseEvent ev) {
	Object source=ev.getSource();
	if(source==remoteTree) {
	    tpRem=remoteTree.getSelectionPath();
	    remotePath=(applet.getRemoteTree()).assembleDirUnix(tpRem);
	    remoteText.setText(remotePath);
	}
	else if(source==localTree) {
	    tpLoc=localTree.getSelectionPath();
	    localPath=(applet.getLocalTree()).assembleDir(tpLoc);
	    localText.setText(localPath);
	}
    }
    
    /**
     * The TreeExpansionEvent object has only one method, getPath().  This 
     * returns the path elements, which can be converted into a directory
     * path (for instance) by using the toString() method and concatenating it.
     *
     * Note that we once again have to use Netscape's privilege manager to 
     * allow file reads.
     */
    public void treeExpanded(TreeExpansionEvent trev){
	Object source=trev.getSource();
	if(source==remoteTree) {
	    (applet.getRemoteTree()).expandChild(trev.getPath());
	}
	else if(source==localTree) {
	    privMan.enablePrivilege("UniversalFileRead");	    
	    (applet.getLocalTree()).expandChild(trev.getPath());
	}
    }

    /**
     * May need to define the following to keep the tree from sucking up
     * too much memory.  Would remove the tree branch when it is closed,
     * replacing the contents with the "<Empty>" placeholder.
     */
    public void treeCollapsed(TreeExpansionEvent trev) {
    }

    private void updateText(JTextField jtf,String message) {
	jtf.setEditable(true);
	jtf.setText(message);
	jtf.setEditable(false);
    }

    //Collect all the empty MouseListener methods here.
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    
}

